function project_run(action)

if nargin == 0
   action = 'init';
end

switch (action)
	case 'init'
      
      h = findobj(allchild(0), 'tag', '2D CWT Project');
		if ~isempty(h)
		   figure(h(1))
	   	return
		end

      fig = projectgui;
      
      handle.edit_scale =findobj(fig, 'Tag', 'EditScale');
      handle.slide_scale =findobj(fig, 'Tag', 'SliderScale');

      handle.InputAxes  = findobj(fig, 'Tag', 'Axes1');
      handle.OutputAxes = findobj(fig, 'Tag', 'Axes2');
      handle.WaveletAxes = findobj(fig, 'Tag', 'Axes3');
      
               
      handle.WarnMsg = findobj(fig, 'Tag', 'WarnMsg');
      handle.PushRun = findobj(fig, 'Tag', 'PushRun');
      handle.PopupWavelet = findobj(fig, 'Tag', 'PopupWavelet');
      handle.PopupInput = findobj(fig, 'Tag','PopupInput');
      handle.window = [];
      	
      % Generate input file list..
      % If you want to add more files, please do it here.
      PopupInput = str2mat('girl','wbarb','lenna','stick','turb2','nanobelts');

      
      set(handle.PopupInput,'String',PopupInput);
      cntStr = deblank(PopupInput(1,:));
      
      
		switch cntStr
	        case 'girl',
            load girl;
            img = girl; 
			case 'wbarb',
      		load wbarb;
            img = wbarb;
			case 'lenna',
      		load lenna;
            img = lenna;
			case 'stick',
		    load stick2;
   	        img = stick2; 	
            case 'turb2',
		    load turb2;
   	        img = turb2;      
            case 'nanobelts',
		    load nanobelts;
   	        img = nanobelts;

            
      otherwise 
   			error('Unknown Image Option!');
      end
      
      img = double(img);
      handle.inputimage = img;
%      subplot(handle.InputAxes);
		image(img,'Parent',handle.InputAxes);
      %colormap(gray(256));
      
      handle.outputimage = [];
      
      wavelet = str2mat('Sombrero','Morlet','Gauss','DerGauss');
      set(handle.PopupWavelet,'String',wavelet);
      
      
      tmp = get(handle.edit_scale,'String');
  	   scale = str2num(tmp);  
      n = length(handle.inputimage);
		xi = [ (0: (n/2)) (((-n/2)+1):-1) ]  ./n;
		omega1 = n .* xi ./scale;
		omega2 = n .* xi ./scale;
	   [o1,o2] = ndgrid(omega1,omega2); 
		handle.window = 2 .* pi .* (o1.^2 + o2.^2) .* exp(-o1.^2 ./2) .* exp(-o2.^2 ./2);
   	%handle.window = handle.window ./ sqrt(scale);
    handle.window = handle.window ./ scale;
   	% save the structure for future reference
      setuprop(fig, 'Handles', handle);
      
   case 'input_image'   
      handle = getuprop(gcf, 'Handles');
      value = get(handle.PopupInput, 'Value');
      signal_name = get(handle.PopupInput,'String');
      cntStr = deblank(signal_name(value,:));

		switch cntStr
			case 'girl',
            load girl;
            img = girl; 
			case 'wbarb',
   			load wbarb;
            img = wbarb; 
			case 'lenna',
      		load lenna;
            img = lenna;
			case 'stick',		
   			load stick2;
            img = stick2; 
            case 'turb2'
   			load turb2;
            img = turb2; 
             case 'nanobelts'
   			load nanobelts;
            img = nanobelts; 
			otherwise 
   			error('Unknown Image Option!');
      end
      
      img = double(img);
      handle.inputimage = img;
%      subplot(handle.InputAxes);
% 		image(img);
      
      handle.outputimage = [];
      setuprop(gcf, 'Handles', handle);
      project_run('draw_image');
      
	case 'select_wavelet'
   
      handle = getuprop(gcf, 'Handles');
      value = get(handle.PopupWavelet, 'Value');
      signal_name = get(handle.PopupWavelet,'String');
   
      cntStr = deblank(signal_name(value,:));
      

		switch cntStr
	      case 'Sombrero',
	   		   tmp = get(handle.edit_scale,'String');
		   	   scale = str2num(tmp); 
      		   n = length(handle.inputimage);
               xi = [ (0: (n/2)) (((-n/2)+1):-1) ]  ./n;
               omega1 = n .* xi ./scale;
					omega2 = n .* xi ./scale;
	   		   [o1,o2] = ndgrid(omega1,omega2); 
					handle.window = 2 .* pi .* (o1.^2 + o2.^2) .* exp(-o1.^2 ./2) .* exp(-o2.^2 ./2);
			   	%handle.window = handle.window ./ sqrt(scale);
                handle.window = handle.window ./ scale;
				   setuprop(gcf, 'Handles', handle);
            project_run('draw_wavelet');
			case 'Morlet',
            set(handle.WarnMsg,'String','Sorry! Not implemented');
            handle.window = [];
            handle.outputimage = [];
      		setuprop(gcf, 'Handles', handle);
            project_run('draw_wavelet');
			case 'Gauss',
            set(handle.WarnMsg,'String','Sorry! Not implemented');
            handle.window = [];
            handle.outputimage = [];
      		setuprop(gcf, 'Handles', handle);
            project_run('draw_wavelet');
         case 'DerGauss'
            set(handle.WarnMsg,'String','Sorry! Not implemented');
            handle.window = [];
            handle.outputimage = [];
      		setuprop(gcf, 'Handles', handle);
            project_run('draw_wavelet');
			otherwise 
   			error('Unknown Image Option!');
      end
       

	case 'run'   
      handle = getuprop(gcf, 'Handles');
      
      value = get(handle.PopupWavelet, 'Value');
      signal_name = get(handle.PopupWavelet,'String');
      cntStr = deblank(signal_name(value,:));
		if strcmp(cntStr,'Sombrero')
      
      set(gcf, 'pointer','watch'); drawnow;
      % read various parameter for noise suppression algorithm
      % initialize warning message  
      set(handle.WarnMsg,'String','');
      x = handle.inputimage;
      
      window = handle.window;
      xhat = fft2(x);
		what = window .* xhat;
		w = ifft2(what);
		cwt= real(w);
	   handle.outputimage = cwt;
           
      setuprop(gcf, 'Handles', handle);
      
      project_run('draw_image');
      project_run('draw_wavelet');
      set(gcf, 'pointer','arrow'); drawnow;
      
   	else
	      set(handle.WarnMsg,'String','Current Wavelet is not supported.');
      
	   end;
   
   case 'draw_image'
		handle = getuprop(gcf, 'Handles');
      subplot(handle.InputAxes);
 		image(handle.inputimage);
      subplot(handle.OutputAxes);
      AutoImage(handle.outputimage);
      
      
   case 'draw_wavelet'
      handle = getuprop(gcf, 'Handles');
      set(handle.WarnMsg,'String','');
      subplot(handle.WaveletAxes);
      mesh(handle.window);
            
   case 'edit_enter'   
      handle = getuprop(gcf, 'Handles');
   	set(gcf, 'pointer','watch'); drawnow;

 
      ttag = get(gcbo, 'Tag');
   	switch(ttag)
      case 'EditScale'
         info = str2num(get(gcbo, 'String'));
         if isempty(info)
            set(handle.WarnMsg,'String','Sorry! scale is invalid');
				set(handle.edit_scale, 'ForegroundColor', [1 0 0]);
            set(handle.edit_scale,'String','30');
            set(handle.slide_scale, 'Value',30);
         elseif (info < 1),
            set(handle.WarnMsg,'String','Sorry! alpha is out of range');
				set(handle.edit_scale, 'ForegroundColor', [1 0 0]);
            set(handle.edit_scale,'String','30');
            set(handle.slide_scale, 'Value',30);
         elseif (info > 100),
            set(handle.WarnMsg,'String','Sorry! alpha is out of range');
				set(handle.edit_scale, 'ForegroundColor', [1 0 0]);
            set(handle.edit_scale,'String','30');
            set(handle.slide_scale, 'Value',30);
         else
            set(handle.WarnMsg,'String','');
            set(handle.edit_scale, 'ForegroundColor', [0 0 0]);
            set(handle.slide_scale, 'Value',info);
         end;
         
   	end
      
		project_run('select_wavelet');      
      set(gcf, 'pointer','arrow'); drawnow;
      
   case 'slide_enter'   
	      handle = getuprop(gcf, 'Handles');
      	set(gcf, 'pointer','watch'); drawnow;
   	   set(handle.WarnMsg,'String','');
      	ttag = get(gcbo, 'Tag');
	   	switch(ttag)
   	   case 'SliderScale'
      	   info = (get(gcbo, 'Value'));
         	set(handle.edit_scale,'String',num2str(floor(info)));
   		end
		   	
		project_run('select_wavelet');      
      set(gcf, 'pointer','arrow'); drawnow;
      
     
	case 'close'
   	close(gcbf);   
      
      
% end of switch(action) 
end



